/*
 *	WallpaperChanger by Y.K
 *	Thanks to plum!
 */

#include <pspsdk.h>
#include <pspkernel.h>
#include <systemctrl.h>
#include <psputilsforkernel.h>
#include <psputils.h>
#include "psploadcore.h"


#define REDIRECT_FUNCTION(a, f) _sw(0x08000000 | (((u32)(f) >> 2) & 0x03FFFFFF), a); _sw(0, a + 4);


PSP_MODULE_INFO("WallpaperChanger", 0x0007, 1, 1);


STMOD_HANDLER previous = NULL;
char deveice_name[5] = "";
char wallpaper_path[256] = "";


int _strlen(const char *str)
{
	const char *top_addr = str;

	while( *str != '\0' )
	{
		str++;
	}

	return (int)(str - top_addr);
}

char *_strcpy(char *dest, const char *src)
{
	char *result = dest;

	while( *dest++ = *src++ );

	return result;
}

char *_strncpy(char *dest, const char *src, int n)
{
	char *result = dest;

	while( 0 < n-- && *src != '\0' )
	{
		if( !(*dest++ = *src++) )
		{
			break;
		}
	}

	*dest = '\0';

	return result;
}

char *_strcat(char *dest, const char *src)
{
	char *result = dest;

	dest += _strlen(dest);

	_strcpy(dest, src);

	return result;
}

int _strcmp(const char *str1, const char *str2)
{
	const unsigned char *ustr1, *ustr2;

	ustr1 = (const unsigned char *)str1;
	ustr2 = (const unsigned char *)str2;

	while( *ustr1 != '\0' && *ustr1 == *ustr2 )
	{
		ustr1++;
		ustr2++;
	}

	return (int)(*ustr1 - *ustr2);
}

/*
// fobOpɍ쐬
// gȂǁA񑀍C̊{Ȃ̂ŎQlɂł

int _strncmp(const char *str1, const char *str2, int n)
{
	const unsigned char *ustr1, *ustr2, *limit;

	ustr1 = (const unsigned char *)str1;
	ustr2 = (const unsigned char *)str2;
	limit = ustr1 + n;

	while( *ustr1 != '\0' && ustr1 < limit )
	{
		if( *ustr1 != *ustr2 )
		{
			break;
		}

		ustr1++;
		ustr2++;
	}

	if( ustr1 == limit )
	{
		ustr1--;
		ustr2--;
	}

	return (int)(*ustr1 - *ustr2);
}

char *_strstr(const char *dest, const char *find)
{
	while( *dest != '\0' )
	{
		if( _strncmp(dest, find, _strlen(find)) == 0 )
		{
			return (char *)dest;
		}

		dest++;
	}

	return NULL;
}
*/

int _rand(int min, int max)
{
	static int flag = 1;
	static SceKernelUtilsMt19937Context ctx;

	if( flag )
	{
		if( sceKernelUtilsMt19937Init(&ctx, (u32)sceKernelLibcTime(NULL)) < 0 )
		{
			return -1;
		}

		flag = 0;
	}

	if( max <= min )
	{
		return -1;
	}

	int length = (max - min) & 0x7FFFFFFF;

	return min + (sceKernelUtilsMt19937UInt(&ctx) + length) % (length + 1);
}

void kuKernelIcacheInvalidateAll(void)
{
	int k1 = pspSdkSetK1(0);
	sceKernelIcacheInvalidateAll();
	pspSdkSetK1(k1);
}

void ClearCaches(void)
{
	sceKernelDcacheWritebackAll();
	kuKernelIcacheInvalidateAll();
}

void *FindModuleStubAddr(SceModule2 *mod, const char *szLib, u32 nid)
{
	int i;
	u32 stub_top, stub_end;
	SceLibraryStubTable *stub;

	stub_top = (u32)mod->stub_top;
	stub_end = (u32)((u32)mod->stub_top + mod->stub_size);

	while( stub_top < stub_end )
	{
		stub = (SceLibraryStubTable *)stub_top;

		if( _strcmp(stub->libname, szLib) == 0 )
		{
			for( i = 0; i < stub->stubcount; i++ )
			{
				if( stub->nidtable[i] == nid )
				{
					return (void *)((u32)(stub->stubtable) + i * 8);
				}
			}
		}

		stub_top += (stub->len * 4);
	}

	return NULL;
}

int is_file(const char *file)
{
	SceIoStat stat;

	return sceIoGetstat(file, &stat) < 0 ? 0 : 1;
}

char *make_new_wallpaper_name(void)
{
	static int flag = 1;
	static char wallpaper_name[256];
	static char *x_pos, *y_pos, *z_pos;

	if( flag )
	{
		flag = 0;

		_strcpy(wallpaper_name, deveice_name);
		_strcat(wallpaper_name, "/PICTURE/Wallpaper/wallpaper");

		x_pos = wallpaper_name + _strlen(wallpaper_name);
		y_pos = x_pos + 1;
		z_pos = x_pos + 2;

		_strcat(z_pos + 1, ".bmp");
	}

	// fmt: /PICTURE/Wallpaper/wallpaperXYZ.bmp
	char x, y, z;

	for( x = '0'; x <= '9'; x++ )
	{
		*x_pos = x;

		for( y = '0'; y <= '9'; y++ )
		{
			*y_pos = y;

			for( z = '0'; z <= '9'; z++ )
			{
				*z_pos = z;

				if( is_file(wallpaper_name) == 0 )
				{
					return wallpaper_name;
				}
			}
		}
	}

	return NULL;
}

int get_file_count(const char *dir)
{
	int count = 0;

	SceUID dfd = sceIoDopen(dir);
	if( dfd >= 0 )
	{
		SceIoDirent dirent = { };

		while( sceIoDread(dfd, &dirent) > 0 )
		{
			if( dirent.d_stat.st_attr & FIO_SO_IFREG )
			{
				count++;
			}
		}

		sceIoDclose(dfd);
	}

	return (count > 1000) ? 1000 : count;
}

int select_wallpaper(char *dest, const char *dir_path)
{
	SceUID dfd = sceIoDopen(dir_path);
	if( dfd < 0 )
	{
		return -1;
	}

	int file_count = get_file_count(dir_path);
	if( file_count == 0 )
	{
		return 1;
	}

	static int prev_wallpaper_num = -1;
	int wallpaper_num = 0;

	if( file_count > 1 )
	{
		do
		{
			wallpaper_num = _rand(0, file_count - 1);
			if( wallpaper_num < 0 )
			{
				return 1;
			}
		}
		while( wallpaper_num == prev_wallpaper_num );

		prev_wallpaper_num = wallpaper_num;
	}

	SceIoDirent dirent = { };
	int count = 0;

	while( sceIoDread(dfd, &dirent) > 0 )
	{
		if( dirent.d_stat.st_attr & FIO_SO_IFREG )
		{
			if( count++ == wallpaper_num )
			{
				_strcpy(dest, dir_path);
				_strcat(dest, "/");
				_strcat(dest, dirent.d_name);
				break;
			}
		}
	}

	sceIoDclose(dfd);

	return 0;
}

SceUID sceIoOpenPatched(const char *file, int flags, SceMode mode)
{
	SceUID fd = -1;

	if( _strcmp(file, "flash1:/vsh/theme/wallpaper.bmp") == 0 )
	{
		if( flags & PSP_O_WRONLY )
		{
			char *new_name = make_new_wallpaper_name();
			fd = sceIoOpen(new_name, flags | PSP_O_CREAT, mode);
		}
		else if( flags & PSP_O_RDONLY )
		{
			int i = 0;
			char wallpaper_name[256];

			while( i++ < 50 )
			{
				int result = select_wallpaper(wallpaper_name, wallpaper_path);
				if( result == 0 )
				{
					fd = sceIoOpen(wallpaper_name, flags, mode);
					break;
				}

				if( result == 1 )
				{
					break;
				}

				sceKernelDelayThread(10000);
			}
		}
	}

	return (fd >= 0) ? fd : sceIoOpen(file, flags, mode);
}

int OnModuleStart(SceModule2 *mod)
{
	if( _strcmp(mod->modname, "scePaf_Module") == 0 )
	{
		void *addr = FindModuleStubAddr(mod, "IoFileMgrForUser", 0x109F50BC);
		if( addr != NULL )
		{
			REDIRECT_FUNCTION((u32)addr, sceIoOpenPatched);
			ClearCaches();
		}
	}

	return previous ? previous(mod) : 0;
}

void make_wallpaper_dirpath(char *dest, const char *deveice)
{
	_strcpy(dest, deveice);

	_strcat(dest, "/PICTURE");
	sceIoMkdir(dest, 0777);

	_strcat(dest, "/Wallpaper");
	sceIoMkdir(dest, 0777);
}

int module_start(SceSize args, void *argp)
{
	_strncpy(deveice_name, (char *)argp , 4);
	make_wallpaper_dirpath(wallpaper_path, deveice_name);

	previous = sctrlHENSetStartModuleHandler(OnModuleStart);

	return 0;
}

int module_stop(SceSize args, void *argp)
{
	return 0;
}
